#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bsp_share.h"

struct shmem_fd shmem_fd;

#define SHMEM_WR_FLAG		0x1122
#define SHMEM_RD_FLAG		0x3344

/* CRC-16 表 */
static const unsigned short Lookup[256]= {
	0x0000,0xC0C1,0xC181,0x0140,0xC301,0x03C0,0x0280,0xC241,
	0xC601,0x06C0,0x0780,0xC741,0x0500,0xC5C1,0xC481,0x0440,
	0xCC01,0x0CC0,0x0D80,0xCD41,0x0F00,0xCFC1,0xCE81,0x0E40,
	0x0A00,0xCAC1,0xCB81,0x0B40,0xC901,0x09C0,0x0880,0xC841,
	0xD801,0x18C0,0x1980,0xD941,0x1B00,0xDBC1,0xDA81,0x1A40,
	0x1E00,0xDEC1,0xDF81,0x1F40,0xDD01,0x1DC0,0x1C80,0xDC41,
	0x1400,0xD4C1,0xD581,0x1540,0xD701,0x17C0,0x1680,0xD641,
	0xD201,0x12C0,0x1380,0xD341,0x1100,0xD1C1,0xD081,0x1040,
	0xF001,0x30C0,0x3180,0xF141,0x3300,0xF3C1,0xF281,0x3240,
	0x3600,0xF6C1,0xF781,0x3740,0xF501,0x35C0,0x3480,0xF441,
	0x3C00,0xFCC1,0xFD81,0x3D40,0xFF01,0x3FC0,0x3E80,0xFE41,
	0xFA01,0x3AC0,0x3B80,0xFB41,0x3900,0xF9C1,0xF881,0x3840,
	0x2800,0xE8C1,0xE981,0x2940,0xEB01,0x2BC0,0x2A80,0xEA41,
	0xEE01,0x2EC0,0x2F80,0xEF41,0x2D00,0xEDC1,0xEC81,0x2C40,
	0xE401,0x24C0,0x2580,0xE541,0x2700,0xE7C1,0xE681,0x2640,
	0x2200,0xE2C1,0xE381,0x2340,0xE101,0x21C0,0x2080,0xE041,
	0xA001,0x60C0,0x6180,0xA141,0x6300,0xA3C1,0xA281,0x6240,
	0x6600,0xA6C1,0xA781,0x6740,0xA501,0x65C0,0x6480,0xA441,
	0x6C00,0xACC1,0xAD81,0x6D40,0xAF01,0x6FC0,0x6E80,0xAE41,
	0xAA01,0x6AC0,0x6B80,0xAB41,0x6900,0xA9C1,0xA881,0x6840,
	0x7800,0xB8C1,0xB981,0x7940,0xBB01,0x7BC0,0x7A80,0xBA41,
	0xBE01,0x7EC0,0x7F80,0xBF41,0x7D00,0xBDC1,0xBC81,0x7C40,
	0xB401,0x74C0,0x7580,0xB541,0x7700,0xB7C1,0xB681,0x7640,
	0x7200,0xB2C1,0xB381,0x7340,0xB101,0x71C0,0x7080,0xB041,
	0x5000,0x90C1,0x9181,0x5140,0x9301,0x53C0,0x5280,0x9241,
	0x9601,0x56C0,0x5780,0x9741,0x5500,0x95C1,0x9481,0x5440,
	0x9C01,0x5CC0,0x5D80,0x9D41,0x5F00,0x9FC1,0x9E81,0x5E40,
	0x5A00,0x9AC1,0x9B81,0x5B40,0x9901,0x59C0,0x5880,0x9841,
	0x8801,0x48C0,0x4980,0x8941,0x4B00,0x8BC1,0x8A81,0x4A40,
	0x4E00,0x8EC1,0x8F81,0x4F40,0x8D01,0x4DC0,0x4C80,0x8C41,
	0x4400,0x84C1,0x8581,0x4540,0x8701,0x47C0,0x4680,0x8641,
	0x8201,0x42C0,0x4380,0x8341,0x4100,0x81C1,0x8081,0x4040
};

static unsigned short crc16(unsigned char *p, int len)
{
	unsigned short crc = 0;
	int zero = 1;

	if (len <= 0)
		return crc;

	while(len-- > 0) {
		if(*p != 0)
			zero = 0;
		crc = Lookup[(crc & 0xff) ^ (*p++)] ^ (crc >> 8);
	}

	if(zero)
		crc=0x5678; /* 若全为0，crc返回就不要为零 */
	return crc;
}

int shmem_read_crc(struct shmem_fd *shmem_fd, void *buf, int len, 
		   int waiting, unsigned short *crc)
{
	volatile struct shmem_block *linux_read = shmem_fd->linux_read;
	unsigned short _crc;

	if (!buf)
		return -EINVAL;

	if (len > shmem_fd->linux_read_data_len) {
		printf("len(%d) != MAX_SHMEM_RD_DATA_LEN(%d)\n", 
			len, shmem_fd->linux_read_data_len);
		return -EINVAL;
	}

	if (linux_read->flag == SHMEM_RD_FLAG)
		goto read;

	if (waiting < 0) {
		while (linux_read->flag != SHMEM_RD_FLAG);
	} else if (waiting > 0) {
		while (waiting-- && linux_read->flag != SHMEM_RD_FLAG)
			usleep(waiting);
	}

	if (linux_read->flag != SHMEM_RD_FLAG)
		return -EBUSY;

read:
	_crc = crc16((void *)linux_read->data, linux_read->len);
	if (_crc != linux_read->crc) {
		printf("crc(%x) != linux_read->crc(%x)\n", 
			_crc, linux_read->crc);
		return -EIO;
	}

	if (len > linux_read->len)
		len = linux_read->len;

	memcpy(buf, (const void *)linux_read->data, len);
	linux_read->flag = 0;

	*crc = _crc;
	return len;
}

int shmem_write_crc(struct shmem_fd *shmem_fd, void *buf, int len,
		    int waiting, unsigned short *crc)
{
	volatile struct shmem_block *linux_write = shmem_fd->linux_write;
	unsigned short _crc;

	if (!buf)
		return -EINVAL;

	if (len > shmem_fd->linux_write_data_len) {
		printf("len(%d) != MAX_SHMEM_WR_DATA_LEN(%d)\n", 
			len, shmem_fd->linux_write_data_len);
		return -EINVAL;
	}

	if (linux_write->flag)
		goto write;

	if (waiting < 0) {
		while (linux_write->flag);
	} else if (waiting > 0) {
		while (waiting-- && linux_write->flag)
			usleep(waiting);
	}

	if (linux_write->flag == SHMEM_WR_FLAG)
		return -EBUSY;

write:
	memcpy((void *)linux_write->data, buf, len);
	_crc = crc16((void *)linux_write->data, len);

	linux_write->crc = _crc;
	linux_write->len = len;
	linux_write->flag = SHMEM_WR_FLAG;

	*crc = _crc;
	return len;
}

int shmem_read(struct shmem_fd *shmem_fd, void *buf, int len, int waiting)
{
	volatile struct shmem_block *linux_read = shmem_fd->linux_read;

	if (!buf || len > shmem_fd->linux_read_data_len)
		return -1;

	if (linux_read->flag == SHMEM_RD_FLAG)
		goto read;

	if (waiting < 0) {
		while (linux_read->flag != SHMEM_RD_FLAG);
	} else if (waiting > 0) {
		while (waiting-- && linux_read->flag != SHMEM_RD_FLAG)
			usleep(waiting);
	}

	if (linux_read->flag != SHMEM_RD_FLAG)
		return -EBUSY;

read:
	if (len > linux_read->len)
		len = linux_read->len;
	memcpy(buf, (const void *)linux_read->data, len);
	linux_read->flag = 0;

	return 0;
}

int shmem_write(struct shmem_fd *shmem_fd, void *buf, int len, int waiting)
{
	volatile struct shmem_block *linux_write = shmem_fd->linux_write;

	if (!buf || len > shmem_fd->linux_write_data_len)
		return -1;

	if (linux_write->flag)
		goto write;

	if (waiting < 0) {
		while (linux_write->flag);
	} else if (waiting > 0) {
		while (waiting-- && linux_write->flag)
			usleep(waiting);
	}

	if (linux_write->flag == SHMEM_WR_FLAG)
		return -EBUSY;

write:
	memcpy((void *)linux_write->data, buf, len);
	linux_write->len = len;
	linux_write->flag = SHMEM_WR_FLAG;

	return 0;
}

#define ARV_SHMEM_REGION_LEN 0x10

int shmem_init(struct shmem_fd *shmem_fd)
{
	int fd;
	void *shmem;
	int ret;

	fd = open("/dev/arv-shmem", O_RDWR);
	if (fd == -1) {
		printf("can not open file /dev/arv-shmem\n");
		return -1;
	}

	ret = ioctl(fd, ARV_SHMEM_REGION_LEN, &shmem_fd->shmem_len);
	if (ret) {
		printf("failed to get the len of shmem\n");
		return -1;
	}
	printf("shmem len: 0x%x\n", shmem_fd->shmem_len);

	shmem_fd->linux_write_len = max_shmem_wr_len(shmem_fd->shmem_len);
	shmem_fd->linux_read_len = max_shmem_rd_len(shmem_fd->shmem_len);
	shmem_fd->linux_write_data_len = max_shmem_wr_data_len(shmem_fd->shmem_len);
	shmem_fd->linux_read_data_len = max_shmem_rd_data_len(shmem_fd->shmem_len);

	shmem = mmap(NULL, shmem_fd->shmem_len, PROT_READ|PROT_WRITE, 
		MAP_SHARED, fd, 0);
	if (shmem <= 0) {
		printf("failed to get shmem\n");
		return -1;
	}
	printf("mmap: %llx\n", (unsigned long long)shmem);
	
	shmem_fd->fd = fd;
	shmem_fd->linux_write = (struct shmem_block *)shmem;
	shmem_fd->linux_read = (struct shmem_block *)(shmem + shmem_fd->linux_write_len);

	return 0;
}

void shmem_exit(struct shmem_fd *shmem_fd)
{
	munmap(shmem_fd->linux_write, shmem_fd->shmem_len);
	close(shmem_fd->fd);
}
